#include <windows.h>
#include "engine.h"

int mainCRTStartup();

static LRESULT CALLBACK WndProc( HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam );
static DWORD WINAPI RenderingThread(LPVOID lpParam);

static HWND IntroWin;
static HINSTANCE hInstance = (HINSTANCE)((unsigned int)mainCRTStartup & 0xffff0000);

static unsigned int ScreenBuffers[2][640*480];
static unsigned int *FrontBuffer = ScreenBuffers[0];
unsigned int *BackBuffer = ScreenBuffers[1];

static bool TheEnd;

static WNDCLASSEX IntroWinClass = 
{
  sizeof(WNDCLASSEX),
  0, 
  WndProc,
  0,
  0,
  (HINSTANCE)((unsigned int)mainCRTStartup & 0xffff0000),
  NULL,
  NULL,
  (HBRUSH)(COLOR_WINDOW),
  NULL,
  "i",
  NULL
};

static BITMAPINFOHEADER bmhdr =
{
  sizeof(BITMAPINFOHEADER),
  640,
  -480,
  1,
  32,
  BI_RGB,
  0,
  0,
  0,
  0,
  0
};

int
mainCRTStartup()
{
  MSG Msg;
  if(!RegisterClassEx(&IntroWinClass)) return 1;
  IntroWin = CreateWindowEx(
      0, "i", "by gynvael.coldwind//vx", WS_POPUP | WS_CAPTION | WS_SYSMENU| WS_VISIBLE, 
      150,150, 640,480,
      NULL, NULL, hInstance, NULL);
  
  while(GetMessage(&Msg, NULL, 0, 0))
  {
    TranslateMessage(&Msg);
    DispatchMessage(&Msg);
  }
  
  return 0;
}

static LRESULT CALLBACK 
WndProc( HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
  PAINTSTRUCT ps;
  HDC hdc;
  DWORD ThreadId;
  static bool ThreadRunning;

  switch( msg )
  {
    case WM_CLOSE:
      DestroyWindow( hwnd );
    break;

    case WM_DESTROY:
      PostQuitMessage( 0 );
      TheEnd = true;
    break;

    case WM_PAINT:
    if(!ThreadRunning)
    {
      CreateThread(NULL, 0, RenderingThread, NULL, 0, &ThreadId);
      ThreadRunning = true;
    }
    hdc = BeginPaint(hwnd, &ps);
    StretchDIBits(hdc, 0, 0, 640, 480, 0, 0, 640, 480, FrontBuffer,
       	(BITMAPINFO*)&bmhdr, DIB_RGB_COLORS, SRCCOPY);
    EndPaint(hwnd, &ps);
    break;

    default:
    return DefWindowProc( hwnd, msg, wParam, lParam );
  }
  return 0;
}

static DWORD WINAPI RenderingThread(LPVOID lpParam)
{
  InitAmethyst();

  while(!TheEnd)
  {
    EngineRender();

    // Swap buffer
    __asm {
      mov eax, FrontBuffer
      xchg eax, BackBuffer
      mov FrontBuffer, eax
    };

    InvalidateRect(IntroWin, NULL, false);
    UpdateWindow(IntroWin);
  }

  return 0;
}

