#include "vector.h"


__declspec(naked) void v_add(DVector *a, DVector *b)
{
  __asm
  {
    mov eax, [esp+4]
    movaps xmm1, [eax]
    mov eax, [esp+8]
    movaps xmm0, [eax]
    addps xmm0, xmm1
    movaps [eax], xmm0
    ret
  };
}

__declspec(naked) void v_sub(DVector *a, DVector *b)
{
  __asm
  {
    mov eax, [esp+4]
    movaps xmm1, [eax]
    mov eax, [esp+8]
    movaps xmm0, [eax]
    subps xmm0, xmm1
    movaps [eax], xmm0
    ret
  };
}

__declspec(naked) float v_dot(DVector *a, DVector *b)
{
  static DVector t;
  __asm
  {
    mov eax, [esp+4]
    movaps xmm0, [eax]
    mov eax, [esp+8]
    movaps xmm1, [eax]
    mulps xmm0, xmm1
    movaps [t], xmm0
    fld dword ptr [t]
    fadd dword ptr [t+4]
    fadd dword ptr [t+8]
    ret
  };
}

__declspec(naked) float v_len(DVector *a)
{
  static DVector t;
  __asm
  {
    mov eax, [esp+4]
    movaps xmm0, [eax]
    mulps xmm0, xmm0
    movaps [t], xmm0
    fld dword ptr [t]
    fadd dword ptr [t+4]
    fadd dword ptr [t+8]
    fsqrt
    ret
 /* SSE sum, way to large
    movaps xmm1, xmm0
    shufps xmm1, xmm1, 0xfe ; 11 11 11 10
    addps xmm0, xmm1
    movaps xmm1, xmm0
    shufps xmm1, xmm0, 0xfd ; 11 11 11 01
    addss xmm0, xmm1
    sqrtss xmm0, xmm0
    movss [len], xmm0*/
  };
}

void v_normalize(DVector *a)
{
  float len = v_len(a);
  a->x /= len;
  a->y /= len;
  a->z /= len;
}

